// 002 u_10_excel_open_create
// 03 dec 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_10_excel_open_create;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Grids, DBGrids, DB, DBTables, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    save_edit_: TEdit;
    save_as_: TButton;
    close_exce_: TButton;
    Panel4: TPanel;
    create_application_: TButton;
    toggle_excel_visible_: TButton;
    Panel5: TPanel;
    create_1_worksheet_: TButton;
    add_workbook_: TButton;
    close_workbooks_: TButton;
    worksheet_edit_: TEdit;
    select_worksheet_: TButton;
    select_worksheet_2_: TButton;
    analyze_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_application_Click(Sender: TObject);
    procedure toggle_excel_visible_Click(Sender: TObject);
    procedure create_1_worksheet_Click(Sender: TObject);
    procedure close_exce_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure save_as_Click(Sender: TObject);
    procedure add_workbook_Click(Sender: TObject);
    procedure close_workbooks_Click(Sender: TObject);
    procedure select_worksheet_Click(Sender: TObject);
    procedure analyze_Click(Sender: TObject);
    procedure select_worksheet_2_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses ComObj,
       Variants
      , Excel97

      , u_types_constants, u_c_log, u_c_display
      , u_file, u_dir
      , u_strings
      , u_handle_files_in_dirs
      ;


    {$R *.DFM}

    const k_initial_directory= 'C:\programs\fr\com\excel\_data';

          k_extension= '.xls';
          k_file_name= 'annuaire.xls';

          k_my_sheet= 'my_sheet';
          k_save_file_name= 'my_sheet.xls';

    var g_path: String= k_initial_directory;
        g_file_name: String= k_file_name;

    var g_c_ole_application: variant;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_directory_listbox_directory(DirectoryListBox1, k_initial_directory);
        save_edit_.Text:= k_save_file_name;

        g_c_ole_application:= Unassigned;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        display_path_and_file;
      end; // DirectoryListBox1Change

    // -- actions

    procedure TForm1.create_application_Click(Sender: TObject);
        // -- create an OLE link for the Excel class
        // --   stored in the Registry
      begin
        g_c_ole_application:= CreateOleObject('Excel.Application');
      end; // create_application_Click

    procedure TForm1.toggle_excel_visible_Click(Sender: TObject);
        // -- togle the visibility of Excel
      begin
        g_c_ole_application.visible:= Not g_c_ole_application.visible;
      end; // excel_visible_Click

    procedure TForm1.create_1_worksheet_Click(Sender: TObject);
      var l_c_worksheet: Variant;
      begin
        l_c_worksheet:= g_c_ole_application.Workbooks.Add(xlWBATWorksheet);
        g_c_ole_application.Workbooks[1].WorkSheets[1].Name:= k_my_sheet;
      end; // create_1_worksheet_Click

    procedure TForm1.add_workbook_Click(Sender: TObject);
      var l_c_ole_workbook: Variant;
      begin
        l_c_ole_workbook:= g_c_ole_application.Workbooks.Add;
      end; // add_workbook_Click

    procedure TForm1.close_workbooks_Click(Sender: TObject);
      begin
        g_c_ole_application.Workbooks.Close;
      end; // close_workbooks_Click

    procedure TForm1.select_worksheet_2_Click(Sender: TObject);
      begin
        g_c_ole_application.Workbooks[1].Sheets[2].Activate;
      end; // select_worksheet_2_Click

    procedure TForm1.select_worksheet_Click(Sender: TObject);
      begin
        g_c_ole_application.Workbooks[1].Sheets[worksheet_edit_.Text].Activate;
      end; // select_worksheet_Click

    procedure TForm1.analyze_Click(Sender: TObject);
      var l_c_ole_worksheet: Variant;
          l_workbook_index: Integer;
          l_sheet_index: Integer;
      begin
        display('> analyze_Click');
        for l_workbook_index:= 1 to g_c_ole_application.Workbooks.Count do
        begin
          display('Workbook: ' + g_c_ole_application.Workbooks[l_workbook_index].Name);
          for l_sheet_index:= 1 to g_c_ole_application.Workbooks[l_workbook_index].Sheets.Count do
          begin
            l_c_ole_worksheet:= g_c_ole_application.Workbooks[l_workbook_index].Sheets[l_sheet_index];
            display('  Sheet: ' + l_c_ole_worksheet.Name);
          end;
        end;
        display('< analyze');
      end; // analyze_Click

    procedure TForm1.save_as_Click(Sender: TObject);
      begin
        g_c_ole_application.ActiveWorkBook.SaveAs(g_path+ save_edit_.Text);
      end; // save_as_Click

    procedure TForm1.close_exce_Click(Sender: TObject);
      begin
        g_c_ole_application.Quit;
        g_c_ole_application:= Unassigned;
      end; // close_exce_Click

end.

